<?php

require_once('../../lib/_autoload.php');
require_once('./Constants.php');
require_once('./StorkMessage.php');
require_once('./StorkHTTPPost.php');

//el nombre del metadata del SP
$authSource = StorkConstants::SPID;

$as = new SimpleSAML_Auth_Simple($authSource);

$session = SimpleSAML_Session::getSessionFromRequest();

if ($session->isValid($authSource)) {
	return;
}

$returnTo = SimpleSAML_Utilities::selfURL();

error_reporting(0);
$state = array_merge(array(), array(
      'SimpleSAML_Auth_Default.id' => $authSource,
      'SimpleSAML_Auth_Default.Return' => $returnTo,
      'SimpleSAML_Auth_Default.ErrorURL' => NULL,
      'LoginCompletedHandler' => array(get_class(), 'loginCompleted'),
      'LogoutCallback' => array(get_class(), 'logoutCallback'),
      'LogoutCallbackState' => array('SimpleSAML_Auth_Default.logoutSource' => $authSource,),)
);

//cargar el metadata del SP
$as = SimpleSAML_Auth_Source::getById($authSource);
$metadata = $as->getMetadata();
//override idp definitions
//$idp = $as->getMetadata()->getString('idp', NULL);

$_POST['spcountry'] = 'ES';
$_POST['country'] = 'ES';

//cargar el metadata del IdP. Para el parámetro ‘country’ se espera que sea puesto por el HTML form
$idp = $_POST['spcountry'];
$idpMetadata = $as->getIdPMetadata($idp);

try {
    $state['saml:sp:AuthId'] = $authSource;
    //cargar extensiones. Se comprueba si se ha pulsado el botón de "Lanzar Petición" o "Petición a medida"
    $porDefecto = $_POST['default'];
    if( $porDefecto ) 
        $extensions = StorkConstants::genDefaultAttrs($_POST);
    else 
        $extensions = StorkConstants::genAttrs($_POST);
  
    //generar una Authentication Request
    $ar = stork_saml_Message::buildAuthnRequestStork($extensions, $metadata, $idpMetadata);
    
    if (isset($state['SimpleSAML_Auth_Default.ReturnURL'])) {
      $ar->setRelayState($state['SimpleSAML_Auth_Default.ReturnURL']);
    }

    if (isset($state['saml:AuthnContextClassRef'])) {
      $accr = SimpleSAML_Utilities::arrayize($state['saml:AuthnContextClassRef']);
      $ar->setRequestedAuthnContext(array('AuthnContextClassRef' => $accr));
    }

    if (isset($state['ForceAuthn'])) {
      $ar->setForceAuthn((bool)$state['ForceAuthn']);
    }

    if (isset($state['isPassive'])) {
      $ar->setIsPassive((bool)$state['isPassive']);
    }

    if (isset($state['saml:NameIDPolicy'])) {
      if (is_string($state['saml:NameIDPolicy'])) {
        $policy = array(
          'Format' => (string)$state['saml:NameIDPolicy'],
          'AllowCreate' => TRUE,
        );
      } elseif (is_array($state['saml:NameIDPolicy'])) {
        $policy = $state['saml:NameIDPolicy'];
      } else {
        throw new SimpleSAML_Error_Exception('Invalid value of $state[\'saml:NameIDPolicy\'].');
      }
      $ar->setNameIdPolicy($policy);
    }

    if (isset($state['saml:IDPList'])) {
        $IDPList = $state['saml:IDPList'];
    } else {
        $IDPList = array();
    }

    $ar->setIDPList(array_unique(array_merge($metadata->getArray('IDPList', array()),
                        $idpMetadata->getArray('IDPList', array()),
                        (array) $IDPList)));

    if (isset($state['saml:ProxyCount']) && $state['saml:ProxyCount'] !== null) {
      $ar->setProxyCount($state['saml:ProxyCount']);
    } elseif ($idpMetadata->getInteger('ProxyCount', null) !== null) {
      $ar->setProxyCount($idpMetadata->getInteger('ProxyCount', null));
    } elseif ($metadata->getInteger('ProxyCount', null) !== null) {
      $ar->setProxyCount($metadata->getInteger('ProxyCount', null));
    }
    
    $requesterID = array();
    if (isset($state['saml:RequesterID'])) {
      $requesterID = $state['saml:RequesterID'];
    }

    if (isset($state['core:SP'])) {
      $requesterID[] = $state['core:SP'];
    }

    $ar->setRequesterID($requesterID);

    $id = SimpleSAML_Auth_State::saveState($state, 'saml:sp:sso', TRUE);
    $ar->setId($id);
   
    $b = new SAML2_StorkHTTPPost($_POST['country'], $_POST);	
	if( $porDefecto ) {
		$ar->setForceAuthn(false);
		$b->sendDefault($ar);
	} else {
		$forceAuth = $_POST['forceAuth'] === 'true';
		$ar->setForceAuthn($forceAuth);
		$b->send($ar);
	}

} catch (SimpleSAML_Error_Exception $e) {
    SimpleSAML_Auth_State::throwException($state, $e);
} catch (Exception $e) {
    $e = new SimpleSAML_Error_UnserializableException($e);
    SimpleSAML_Auth_State::throwException($state, $e);
}

?>
